//
// @doc
//
// @file DLG.CPP |
//

// DLG includes
#include "dlg.hpp"

// Standard C++ includes
#include <algorithm>
#include <string>
#include <sstream>

// Debug includes
#include <cassert>

/************************************************
*
*          EXPRESSION BUILDER DIALOG
*
************************************************/

// TestDlg dialog
//

BEGIN_MESSAGE_MAP(TestDlg, CDialog)
    // Tab notifications
  ON_NOTIFY(TCN_SELCHANGE, IDC_TAB , OnClickTabCtrl)
END_MESSAGE_MAP()


TestDlg::TestDlg( CWnd* pParent /*=NULL*/)
  : CDialog(TestDlg::IDD, pParent), m_nMaxTabs(20)
{
}

TestDlg::~TestDlg()
{
}

void TestDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);

//  DDX_Control(pDX, IDC_NUMBER_TABS, m_MaxTabsControl);
//  DDX_Control(pDX, IDC_NUMBER_TABS_SPIN, m_SpinControl);
  DDX_Control(pDX, IDC_TAB , m_TabControl);
  DDX_Control(pDX, IDC_TEXT, m_TextControl);


//  DDX_Text(pDX, IDC_NUMBER_TABS, (UINT)m_nMaxTabs );

//  DDX_Slider(pDX,IDC_NUMBER_TABS_SPIN,&m_nMaxTabs); 

}

BOOL TestDlg::OnInitDialog()
{
  // Default MFC processing
  CDialog::OnInitDialog();

  TC_ITEM item;

  item.mask = TCIF_TEXT;

  for( unsigned int nTab = 0; nTab < m_nMaxTabs; nTab++ )
  {
    std::ostringstream ostr;
    ostr << "Tab " << nTab;
    std::string str = ostr.str();
    item.pszText    = const_cast<char*>(str.c_str());
    item.cchTextMax = static_cast<int>(str.length());
    m_TabControl.InsertItem( nTab, &item );
  }
  
  return(FALSE);  // return TRUE  unless you set the focus to a control
}

//
// 'TestDlg::OnClickTabCtrl'
//
// @mfunc Notification handler that is called whenever a tab has
//        been selected.
//
void TestDlg::OnClickTabCtrl(NMHDR* pNotifyStruct, LRESULT* pResult)
{
  // Get the currently active tab
  int nCurTab = m_TabControl.GetCurSel();

  std::ostringstream ostr;
  ostr << "This is tab " << nCurTab;
  
  m_TextControl.SetWindowText( ostr.str().c_str() );

  // Set the return code
  *pResult = 0;
}


// END DLG.CPP

